#include "vertexarray.h"
#include "vertexarraybuilder.h"

namespace Msp {
namespace GL {

VertexArrayBuilder::VertexArrayBuilder(VertexArray &a):
	array(a)
{ }

void VertexArrayBuilder::vertex_(const Vector4 &vtx)
{
	float *ptr = array.append();
	const VertexFormat &format = array.get_format();
	for(const unsigned char *a=format.begin(); a!=format.end(); ++a)
	{
		unsigned sem = get_attribute_semantic(*a);
		unsigned sz = get_attribute_size(*a);
		if(sem>=attr.size())
			ptr += sz;
		else if(*a==COLOR4_UBYTE)
		{
			union { unsigned char c[4]; float f; } u;
			u.c[0] = static_cast<unsigned char>(attr[sem].x*255);
			u.c[1] = static_cast<unsigned char>(attr[sem].y*255);
			u.c[2] = static_cast<unsigned char>(attr[sem].z*255);
			u.c[3] = static_cast<unsigned char>(attr[sem].w*255);
			*ptr++ = u.f;
		}
		else
		{
			const Vector4 &v = (sem==0 ? vtx : attr[sem]);
			*ptr++ = v.x;
			if(sz>=2) *ptr++ = v.y;
			if(sz>=3) *ptr++ = v.z;
			if(sz>=4) *ptr++ = v.w;
		}
	}
}

} // namespace GL
} // namespace Msp
